package com.logicbig.example;

import java.lang.StackWalker.StackFrame;
import java.util.Optional;

public class StackWalkerGetCallerWithWalkMethod {
    public static void main(String[] args) {
        TheCallerClass sc = new TheCallerClass();
        sc.doSomething();
    }

    public static final class TheCallerClass {
        public void doSomething() {
            TheCalleeClass theCalleeClass = new TheCalleeClass();
            theCalleeClass.work();
        }
    }

    public static final class TheCalleeClass {
        public void work() {
            StackWalker instance = StackWalker.getInstance(StackWalker.Option.RETAIN_CLASS_REFERENCE);
            Optional<? extends Class<?>> opt = instance.walk(
                    stream -> stream.map(StackFrame::getDeclaringClass)
                                    .skip(1)
                                    .findFirst());
            if (opt.isPresent()) {
                Class<?> aClass = opt.get();
                System.out.println(aClass);
            }
       }
    }
}